                .386P
STCK_LEN        equ     100h
extrn           _pm_info:far,_pm_init:far
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_PMODE_TEXT     Segment Para Public Use16 'CODE'
_PMODE_TEXT     EndS
_TEXT           Segment Para Public Use16 'CODE'
_TEXT           EndS
_PMODE32        Segment Para Public Use32 'CODE'
_PMODE32        EndS
_STACK          Segment Para Stack
_STACK          EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_TEXT           Segment Para Public Use16 'CODE'
                Assume  cs:_TEXT,ds:_TEXT,ss:_STACK
                org     0
;
ErrorTable      dw      Error_1,Error_2,Error_3,Error_4,Error_5,Error_6,Error_7
                dw      Error_8
Error_1         db      "80386 or better not detected.",13,10,"$"
Error_2         db      "System is already in protected mode and no VCPI or DPMI found.",13,10,"$"
Error_3         db      "DPMI - host isn't 32-bit.",13,10,"$"
Error_4         db      "Couldn't enable A20 gate.",13,10,"$"
Error_5         db      "DPMI - Couldn't enter into 32-bit protected mode.",13,10,"$"
Error_6         db      "DPMI - Couldn't allocate needed selectors.",13,10,"$"
Error_7         db      "DPMI not present.",13,10,"$"
Error_8         db      "XMS - Too old version (v3.0+ needed).",13,10,"$"
NoLoMem         db      "Not enough low memory.",13,10,"$"
;
                align   4
_TEXT_codebase  dd      0
_TEXT_codesel   dw      0
_TEXT_datasel   dw      0
_TEXT_pspsel    dw      0
_TEXT_zdatasel  dw      0
_TEXT_dpl       db      0
_pmode_type     db      0
;
Start:          push    cs
                pop     ds
                call    _pm_info
                jnc     S_Continue
Error:          mov     bx,ax
                add     bx,ax
                mov     dx,ErrorTable[bx-2]
ErrorMessage:   mov     ah,09h
                int     21h
                mov     ax,4CFEh
                int     21h

S_Continue:     mov     _pmode_type,ch
                mov     cx,_STACK
                add     cx,STCK_LEN
                mov     ax,es:[2]
                sub     ax,cx
                cmp     ax,bx
                mov     dx,offset NoLoMem
                jb      ErrorMessage

                push    cx
                mov     dx,es
                sub     cx,dx
                add     bx,cx
                add     bx,10h
                mov     ah,4Ah
                int     21h
                pop     es

                call    _pm_init
                jc      Error

                mov     eax,_PMODE_TEXT
                mov     dx,cs

                mov     _TEXT_codebase,eax
                mov     _TEXT_codesel,dx
                mov     _TEXT_datasel,ds
                mov     _TEXT_pspsel,es

                lar     ax,dx
                and     ah,60h
                mov     _TEXT_dpl,ah

                mov     ebx,_PMODE32
                shl     ebx,4
                mov     edx,0FFFFFFFFh
                mov     bp,1100000010011010b
                call    alloc_desc

                push    ebx
                push    large offset Start32

                xor     ebx,ebx
                mov     edx,0FFFFFFFFh
                mov     bp,1100000010010010b
                call    alloc_desc
                mov     _TEXT_zdatasel,bx
                mov     fs,bx

                mov     ebx,_PMODE32
                shl     ebx,4
                mov     edx,0FFFFFFFFh
                mov     bp,1100000010010010b
                call    alloc_desc

                mov     al,cs:_pmode_type
                mov     ds,bx

                db      66h
                retf
;
alloc_desc:     ; EBX = Base address
		; EDX = Limit
		;  BP = Access Rights
                xor     ax,ax
		mov	cx,1
		int	31h
		jc	ad_exit

		push	edx
		mov	dx,bx
		rol	ebx,16
		mov	cx,bx
		mov	bx,ax
		mov	ax,7
		int	31h
		pop	dx cx
		jc	ad_exit

		mov	ax,8
		int	31h
		jc	ad_exit

		mov	ax,9
		mov	cx,bp
                or      cl,_TEXT_dpl
		int	31h
		jc	ad_exit

                ret

ad_exit:        pop     ax
                mov     ax,6
                jmp     Error
;
_TEXT           EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_PMODE32        Segment Para Public Use32 'CODE'
                Assume  cs:_PMODE32,ds:_PMODE32
;
                org     0
PM_Codebase     dd      0
PM_Code         dw      0,0
PM_Data         dw      0,0
PM_ZData        dw      0,0
PM_PSP          dw      0,0
PM_PIC_Master   db      0
PM_PIC_Slave    db      0
;
JaRulez         db      "32-bit protected mode rulez... ;)",13,10,"$"
;
Start32:        mov     eax,_PMODE32
                shl     eax,4
                mov     PM_Codebase,eax
                mov     PM_Code,cs
                mov     PM_Data,ds
                mov     PM_ZData,fs
                mov     PM_PSP,es

                mov     edx,offset JaRulez
                mov     ah,09h
                int     21h

exit:           mov     ax,4C00h
                int     21h
;
_PMODE32        EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_STACK          Segment Para Stack
                db      10h*STCK_LEN dup (0)
_STACK          EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
                End     Start
